/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (I)         *
 *            - vO~O̊bE\[XECxg -             *
 *                                                                     *
 *      Copyright 1994,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>
#include <X11/cursorfont.h>  /* "?" }[ÑJ[\̍쐬ɕKv */

static Widget toplevel;
static Widget dialog;
static Cursor question;

/* ut@Cvj[̍ڂI΂ꂽƂ̃R[obN */
static void FileMenuCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    int menu_item = (int)client_data;  /* I΂ꂽj[ڂ̔ԍ */
    printf("File Menu: item %d is selected\n", menu_item);

    if (menu_item == 3)  /* 3 Ԗڂ̃j[ (uIv) Ȃ */
        exit(0);         /* vOI */
}

/* uwvvj[̍ڂI΂ꂽƂ̃R[obN */
static void HelpMenuCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget   context;
    XEvent   event;
    char     string[BUFSIZ];
    XmString message;

    int menu_item = (int)client_data;  /* I΂ꂽj[ڂ̔ԍ */
    printf("Help Menu: item %d is selected\n", menu_item);

    if (menu_item == 0) {  /* j[ԍ 0 ́uReLXgvwv */
        /* CxgƐ肵āA[UɃEBWFbgI΂ */
        context = XmTrackingEvent(toplevel, question, False, &event);
        if (context == NULL)                /* ȂꏊI񂾂 */
            XBell(XtDisplay(toplevel), 0);  /* x炵č} */
        else {
            /* wvEbZ[W̕쐬 */
            sprintf(string, "Help message for widget `%s'", XtName(context));
            /* RpEhEXgOɕϊ */
            message = XmStringCreateLocalized(string);
            /* bZ[W_CAOɐݒ */
            XtVaSetValues(dialog, XmNmessageString, message, NULL);
            XmStringFree(message); /* svȃRpEhEXgO */
            XtManageChild(dialog); /* _CAOʂɏo */
        }
    }
}

/* I΂ꂽeLXgNbv{[hɃRs[ */
static void CopyCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;
    XmTextCopy(text, XtLastTimestampProcessed(XtDisplay(text)));
}

/* I΂ꂽeLXgNbv{[hɃJbg */
static void CutCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;
    XmTextCut(text, XtLastTimestampProcessed(XtDisplay(text)));
}

/* Nbv{[h̃f[^eLXgɃy[Xg */
static void PasteCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;
    XmTextPaste(text);
}

/* j[o[ƃv_EEj[쐬 */
static Widget CreateMenu(parent)
    Widget parent;
{
    Widget  menubar, filemenu, helpbutton, helpmenu;
    Arg     al[20];
    int     ac;
    int     n = 0;

    /* j[o[쐬 */
    menubar = XmVaCreateSimpleMenuBar(parent, "menubar",
                XmVaCASCADEBUTTON, NULL, NULL,  /* ut@Cvj[ */
                NULL);
    XtManageChild(menubar);

    /* ut@Cvv_EEj[쐬 */
    filemenu = XmVaCreateSimplePulldownMenu(menubar, "filemenu",
                  n++, FileMenuCB,
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL,  /* uVKv */
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL,  /* uI[vv */
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL,  /* uۊǁv */
                  XmVaSEPARATOR,  /* Zp[^ (j[ڂ̋؂) */
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL,  /* uIv */
                  NULL);

    /* uwvvj[̃{^쐬 */
    ac = 0;
    helpbutton = XmCreateCascadeButtonGadget(menubar, "helpbutton", al, ac);
    XtManageChild(helpbutton);

    /* uwvvj[j[o[̉E[ɒu */
    XtVaSetValues(menubar, XmNmenuHelpWidget, helpbutton, NULL);

    helpmenu = XmVaCreateSimplePulldownMenu(menubar, "helpmenu",
                  n++, HelpMenuCB,
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL, /*uReLXgv*/
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL, /*uTvv*/
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL, /*uo[Wv*/
                  NULL);

    return(menubar);
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget  mainwin, menubar, work, text, command, copy, cut, paste;
    Arg     al[20];
    int     ac;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Contexthelp", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    dialog = XmCreateInformationDialog(toplevel, "dialog", al, ac);
    XtUnmanageChild(XmMessageBoxGetChild(dialog, XmDIALOG_CANCEL_BUTTON));
    XtUnmanageChild(XmMessageBoxGetChild(dialog, XmDIALOG_HELP_BUTTON));

    ac = 0;
    XtSetArg(al[ac], XmNshowSeparator, True); ac++;
    XtSetArg(al[ac], XmNcommandWindowLocation, XmCOMMAND_BELOW_WORKSPACE); ac++;
    mainwin = XmCreateMainWindow(toplevel, "mainwin", al, ac);
    XtManageChild(mainwin);

    menubar = CreateMenu(mainwin);   /* j[쐬 */

    ac = 0;
    work = XmCreateRowColumn(mainwin, "work", al, ac);
    XtManageChild(work);

    ac = 0;
    command = XmCreateRowColumn(mainwin, "command", al, ac);
    XtManageChild(command);

    XmMainWindowSetAreas(mainwin, menubar, command, NULL, NULL, work);

    ac = 0;
    text = XmCreateText(work, "text", al, ac);
    XtManageChild(text);

    ac = 0;
    copy = XmCreatePushButton(command, "copy", al, ac);
    XtManageChild(copy);
    ac = 0;
    cut = XmCreatePushButton(command, "cut", al, ac);
    XtManageChild(cut);
    ac = 0;
    paste = XmCreatePushButton(command, "paste", al, ac);
    XtManageChild(paste);

    XtAddCallback(copy,  XmNactivateCallback, CopyCB,  text);
    XtAddCallback(cut,   XmNactivateCallback, CutCB,   text);
    XtAddCallback(paste, XmNactivateCallback, PasteCB, text);

    /* ANZ[^eLXgɃCXg[ */
    XtInstallAccelerators(text, copy);
    XtInstallAccelerators(text, cut);
    XtInstallAccelerators(text, paste);

    XtRealizeWidget(toplevel);

    /* "?" }[ÑJ[\쐬 */
    question = XCreateFontCursor(XtDisplay(toplevel), XC_question_arrow);

    XtAppMainLoop(app_context);
}
